
/*
 * Copyright 2011-2022 Cuberite Contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include "Globals.h"  // NOTE: MSVC stupidness requires this to be the same across all modules

#include "Color.h"





#define COLOR_RED_BITS     0x00FF0000
#define COLOR_GREEN_BITS   0x0000FF00
#define COLOR_BLUE_BITS    0x000000FF
#define COLOR_RED_OFFSET   16
#define COLOR_GREEN_OFFSET 8





void cColor::SetColor(unsigned char a_Red, unsigned char a_Green, unsigned char a_Blue)
{
	m_Color = (static_cast<unsigned int>(a_Red) << COLOR_RED_OFFSET) + (static_cast<unsigned int>(a_Green) << COLOR_GREEN_OFFSET) + (static_cast<unsigned int>(a_Blue));
}





void cColor::SetRed(unsigned char a_Red)
{
	m_Color = (static_cast<unsigned int>(a_Red) << COLOR_RED_OFFSET) + ((COLOR_GREEN_BITS | COLOR_BLUE_BITS) & m_Color);
}





void cColor::SetGreen(unsigned char a_Green)
{
	m_Color = (static_cast<unsigned int>(a_Green) << COLOR_GREEN_OFFSET) + ((COLOR_RED_BITS | COLOR_BLUE_BITS) & m_Color);
}





void cColor::SetBlue(unsigned char a_Blue)
{
	m_Color = static_cast<unsigned int>(a_Blue) + ((COLOR_RED_BITS | COLOR_GREEN_BITS) & m_Color);
}





unsigned char cColor::GetRed() const
{
	return static_cast<unsigned char>((m_Color & COLOR_RED_BITS) >> COLOR_RED_OFFSET);
}





unsigned char cColor::GetGreen() const
{
	return (m_Color & COLOR_GREEN_BITS) >> COLOR_GREEN_OFFSET;
}





unsigned char cColor::GetBlue() const
{
	return m_Color & COLOR_BLUE_BITS;
}
